//-------------   ------------
robotName = "";	//  

//     
frameset("robotName")
{
	frame("|") { return 1; }
}

RobotGender(0);				//   0 - , 1 - 
serialNumber = 233;			//    (    ,    )
useMySQL = false;			//  mysql    
useFaceRecognizer = false;  //      (  )
useAutoCharge = false;		//      
useStrafe = false;          //    
useChangeMode = false;		//         "<>,  "
useLift = false;            //    
city = "";			//   


MAP_MODE = false;			// true,           
WANDERING_MODE = false;		// true,          
canMoving = false;			//     
//-----------------------   ----------------------



//-----------------------     ----------------
placeIndex = 0;				//       places

places = array(3,4,5,6,7,8);//    (   )
basePlace = 2;				//     ,      
chargePlace = 1;			//    ,   (  )


startWorkTime = 10*60 + 15;	//      ,    
endWorkTime = 21*60 + 30;	//      ,    
placeStandUpTime = 60;		//  ()         
maxPlaceStandUpTime = 15*60;//  (),       
//--------------------------      ----------------




//       
lastCity = city;

//  
include("cities.i");

//  
include("currencies.i");


//     
include("weather.i");

//  -
include("def-chatbot.i");


//  
include("services.i");


//--------------------   ------------------
speechTime = GetTickCount();	//    
subjectMask = 0;				//    .   ,   
hasFace = false;				//   .    "* faceIn"  "* faceOut"
nonfaceHello = false;			//  ,      -,      (,         )
isError = false;				//   (,  )
activeMode = true;				//  (true)   (false) .   -    .   -   
speechEnable = true;			//     .   
lockHello = false;				//  
lastGender = -1;


//      (  )
//            ,   
//   
forceChargeMode = false;

//      (  )
//            ,
//           
forceWorkMode = false;


//    ,  "  "
function GetGoodDay()
{
	var tm = localtime(time());
	var h = tm.hour;
	if (h < 4 || h >=23) return "  ";
	if (h < 11) return " ";
	if (h < 18) return " ";
	return " ";
}


//   true,    
function IsWorkTime()
{
	//   
	tm = localtime(time());
	minutes = tm.hour * 60 + tm.min;

	//   
	return minutes >= startWorkTime && minutes <= endWorkTime;
}



frameset("commands",100)
{
	//     
	frame("* SPEECH")
	{
		print("Speech detected!\n");

		//     .
		//       
		//speechTime = GetTickCount();
	}

	psyRiskControl = false;

	frame("* PATIENT <name>")
	{
		if (psyRiskControl) return;

		var name = TextOf("name");

		SetTaskPrior(0);
		if (PsyRiskControl(name)==-1)
		{
			PlaySpeech("    ");
			return;
		}
		psyRiskControl = true;

		while(PsyRiskControl()!=3)
		{
			sync();
		}

		SetBrowserURL("PsyRiskControl.php?file="+URLEncode(GetPsyRiskControlFileName(".pdf")));
        
        speechTime = GetTickCount();
        activeMode = true;
		psyRiskControl = false;
		
	}




	//   
	frame("* faceIn")
	{
		Go(false);
		Wandering(false);
		faceTrigger = true;

		var info;
		if (useFaceRecognizer)
		{
			//    ,     
    		info = GetFaceStatistic(1900, true);
    		print("age="+info.age+" gender="+info.gender+" person="+info.person+"\n");
    		//   
    		

    		var isPerson = false;
    		if (info.person!='')
    		{
    			//   ,   info.person -     
    			var personName = info.person;
    			lastPerson = info.person;
    			isPerson = true;
    			var passedTime2 = 1000;

    			if (useMySQL)
    			{
    				//      mysql,     info.person   
        			if (mysql_connect())
        			{
        				if (mysql_query("SELECT persons.`id` as `id`, persons.`name` as `name`, MIN(UNIX_TIMESTAMP(NOW()) - UNIX_TIMESTAMP(events.`time`)) as `passedTime` FROM persons, events WHERE persons.`folder`='"+info.person+"' AND persons.`id`=events.`person` GROUP BY persons.`id`"))
        				{
        					if (row = mysql_fetch_assoc())
        					{
        						
        						if (row.person != lastPerson)
        						{
        							mysql_query("INSERT INTO events (`time`,`person`) VALUES (NOW(), " + row.id + ")");
        							personName = row.name;
        							passedTime2 = toInt(row.passedTime);
        						}
        						else
        						{
        							lastPerson = '';
        						}	
        					}
        					mysql_free_result();
        				}
        				mysql_close();
        			}
        			else
        			{
        				lastPerson = '';
        				print("Can't connect to mysql");
    				}
    			}

    			print("Passed time ",passedTime2,"\n");

    			//        
    			if (info.age > 18 || info.gender < 0)
        		{
        			print("5555555\n");
        			if (passedTime2 > 600)
        			{
        				print("6666666\n");
        				PlaySpeech(" , "+personName,
						   "(G:|)  , "+personName);

    					if (passedTime2 <= 43200)
    					{
    						//   "".  
    						PlaySpeech("(G:| ),      ",
    							"(G:| ),     ",
    							"  (G:|),     ",
    							"  (G:|),    "
    							);
    					}
    					else
    					if (passedTime2 < 432000)
    					{
    						//   "".   
        					PlaySpeech("(G:|),   ",
        							"(G:|),    ",
        							" (G:|),   ",
        							"  (G:|),    ",
        							"(G:|)   ",
        							"    (G:|).");
        				}	
        				else
        				{
        					//   "".   
        					PlaySpeech(	"      ",
        							"     (G:|)");
        				}
        			}
        		}
        		else
        		{
        			print("77777\n");
        			if (passedTime2 > 600)
        			{
            			PlaySpeech(",  "+personName, ", "+personName, ", "+personName);

        				if (passedTime2 <= 12 * 3600)
        				{
        					if (info.gender ==0)
        					{
            					// .  
            					PlaySpeech("(G:| ),      ",
            								"(G:| ),     ",
            								"  (G:|),     "
            								);
            				}
            				else
            				{
            					// .  
            					PlaySpeech("(G:|),      ",
            								"(G:|),     ",
            								"  (G:|),     "
            							);
            				}
            			}
            			else
            			{
            				if (info.gender ==0)
            				{
            					// .  
            					PlaySpeech("(G:|),   ",
            							"(G:| ),    ",
            							" (G:|),   ");
            				}
            				else
            				{
            					// .  
            					PlaySpeech("(G:| ),   ",
            								"(G:|),    ",
            								"(G:|),   ");
            				}	
            			}
            		}	
        		}
        		if (info.gender >= 0) lastGender = info.gender;
    		}
    	}
    	else
    	{
    		//     ,  ,     
    		info = object();
    		info.gender = -1;
    		info.age = -1;
    		info.person = "";
    		isPerson = false;
    		hasFace = activeMode;
    	}	


		if (!isPerson)
		{
			if (lastGender != info.gender) hasFace = false;

			if (!hasFace)
			{
				if (info.gender == 1)
				{
					// 
					if (info.age > 45)
						PlaySpeech(", ", GetGoodDay() + ", ");
					else
					if (info.age >= 14 || info.age < 0)
						PlaySpeech(",  "," ,  ", GetGoodDay() + ",  ");
					else
						PlaySpeech("","",GetGoodDay());
				}
				else
				if (info.gender == 0)
				{
					// 
					if (info.age > 42)
						PlaySpeech(", ", GetGoodDay() + ", ");
					else
					if (info.age >= 16 || info.age < 0)
						PlaySpeech(",  ", GetGoodDay() + ",  ");
					else
						PlaySpeech("","",GetGoodDay());
				}
				else
				{
					//   
					PlaySpeech(" ","",GetGoodDay());
				}
				if (!activeMode)
				{
					subjectMask = 0;	//     
					hasFace = true;
					lastGender = info.gender;
				}	
			}	
		}
		activeMode = true;	
	}
	
	
	//   
	frame("* faceOut")
	{
		hasFace = false;
		nonfaceHello = false;
	}

	frame("* SPEECH OFF")
	{
		//    
		speechEnable = false;
	}

	frame("* SPEECH ON")
	{
		//    
		speechEnable = true;
	}

	//   
	frame("* ACTIVE")
	{
		activeMode = true;
		Go(false);
		Wandering(false);
		noparkerror = true;

		Park(false);

		

		if (!hasFace && !nonfaceHello && !isError)
		{
			nonfaceHello = true;
			subjectMask = 0;
			PlaySpeech(" ","",GetGoodDay(), "  ");
		}
			
	}

	//        
	frame("* LOCK HEAD")
	{
		LockFaceTrackerHead(true);
	}

	//        
	frame("* ULOCK HEAD")
	{
		LockFaceTrackerHead(false);
	}

	//      -  -    
	frame("* beep")
	{
		activeMode = true;
		//-------------  1   -   -----------
		// PlaySpeech(" "," ","  ");
		//-------------   1 -----------------------------------------

		//--------  2   -    ------
		Go(false);

		Head(0,0);
		
		if (!hasFace && !nonfaceHello)
		{
			nonfaceHello = true;
			subjectMask = 0;	//     
			PlaySpeech(""," ", GetGoodDay(), "  ");
		}
		//----------   2 ----------------------------------------------
	}
}


frameset("phrases",1)
{
	frame("  ")
	frame("  ")
	frame("  |")
	frame(" | ")
	frame(" ")
	frame("  ")
	frame("  ")
	frame(" ")
	frame("  ")
	{
		lockHelloTime = GetTickCount();
		PlaySpeech("     ",""," ");
		var info = GetFaceStatistic(1800, true);
		print("age="+info.age+" gender="+info.gender+" person="+info.person+"\n");
		
		var personName = '';

		if (info.person!='')
		{
			if (useMySQL)
			{
    			if (mysql_connect())
    			{
    				var folder2 = mysql_escape_string(info.person);
    				if (mysql_query("SELECT `name` FROM persons WHERE `folder`='"+folder2+"'"))
    				{
    					if (row = mysql_fetch_assoc())
    					{
    						personName=row.name;
    					}
    					mysql_free_result();
    				}
    				mysql_close();
    			}
    		}
    		else
    		{
    			personName = info.person;
    		}	

			if (personName!='')
			{
				if (info.age<=0 || info.age > 18 || info.gender < 0)
				{
					PlaySpeech(",  , , "+row.name,
						",    . , "+row.name);
				}
				else
					PlaySpeech(",    . , "+row.name, ",    , , "+row.name, "    . , "+row.name);
				return;
			}							
		}
		PlaySpeech(",    ",",     ","-     ");
	}




	frame("<r:robotName>   |IP |IP-")
	frame("<r:robotName>    |IP |IP-")
	{
		var ipList = GetIPAddressList();
		var s = "     ";
		for(var i=0; i < count(ipList); i++)
		{
			if (i>0)
			{
				var n = rand(3);
				if (n==0) s+=".    ";
				else
				if (n==1) s+=".    ";
				else
				s+=".    ";
			}	

			s+=toString(ipList[i][0]) + ", " + toString(ipList[i][1]) + ", " + toString(ipList[i][2]) + ", " + toString(ipList[i][3]);
		}
		PlaySpeech(s);
	}

}



//         
//   true,    .  false,    
function Wait(ms)
{
	while(PlaySpeech()) sync();
	sleep(ms);
	if (RobotSilenceTime() < ms) return false;
	return true;
}


//      
function RobotDialogs()
{
	if (robotDialogCount == 0) return;

	//      rbot-chatbot.i      UI
	//  0 -   .
	//  1....  n -  
	//  n -  ,    ,     
	//       .
	//
	//       subjectMask    1,
	//   .
	//  1, ,        
	

	if (subjectMask == 0)
	{
		//  
		subjectMask|=1;
		RobotDialog(0);
		return;
	}
	else
	{
		//  
		var allMask = (1<<robotDialogCount)-1; //  ,    

		if (subjectMask == allMask)
		{
			//     ,    
			RobotDialog(robotDialogCount-1);
		}
		else
    	for(var i=0; i < robotDialogCount*2; i++)
    	{
  			//     1  
    		var n = rand(1,robotDialogCount);
    		var mask = 1<<n;
    		if (!(subjectMask & mask))
    		{
    			//     ,   ,      
    			subjectMask|=mask;
    			RobotDialog(n);
    			return;
			}
		}
	}
}    			

//---------------------   ----------------
FaceTracker(true, true);	//     
if (useFaceRecognizer) FaceRecognizer(true);
SpeechRecognizion(true);	//   
LockFaceTrackerHead(false);	//   

SetBrowserURL('index.php');

activeModeStartTime = 0;	//       0

//  ,      
Head(10,10);
sleep(100);
Head(0,0);
sleep(1000);

chargeConnected = false;

modeRotDir = true;			//   

//  
while(true)
{
    sync();


    //   
    if (useAutoCharge)
    {
		if (IsChargeConnected())
		{
			if (!chargeConnected)
			{
				//      ,
				//           
				chargeConnected = true;

				if (isError)
				{
					SetBrowserURL('index.php');
				}
			
			

				placeIndex = 0;
				activeMode = true;
				Wandering(false);
				Go(false);
			
				//     
				SetCurrentPlace(chargePlace);
			}
			chargeConnectTime = GetTickCount();
		}
		else
		{
			if (chargeConnected)
			{
				if (GetTickCount() - chargeConnectTime > 6000)
				{
					chargeConnected = false;
				}
			}
		}
	}
	

	//    (   )
	if (activeMode)
	{
		//      ,      
		if (activeModeStartTime == 0)
		{
		    LockFaceTrackerHead(false);
			activeModeStartTime = GetTickCount();
		}

        
        //       ,   
        if ((WANDERING_MODE || MAP_MODE) && !chargeConnected && !PlaySpeech() && GetTickCount() - activeModeStartTime > 10*60 *1000)
        {
        	activeModeStartTime = GetTickCount() - 9 *60 * 1000;
        	PlaySpeech("   ","     ",",    ");
        	Head(0);

        	//     ,   ,    
        	SetWheelSpeed(0, modeRotDir ? 30 : -30);
        	modeRotDir=!modeRotDir;
        	sleep(1000);
        	SetWheelSpeed(0);

        	//   ,     
        	if (!IsFace())
        	{
				activeMode = false;
				subjectMask = 0;
				nonfaceHello = false;
        	}
        }


		//   - ,     	
		if (PlaySpeech()) speechTime = GetTickCount();


		//  n   ...
		if (GetTickCount() - speechTime > 13000)
		{
			speechTime = GetTickCount()+rand(8000);
			if (hasFace)	//   ,    
				RobotDialogs();
			else
			{
				//   ,   
				lastGender = -1;
				lastPerson = '';
				lastAge = -1;
				subjectMask = 0;
				activeMode = false;
				nonfaceHello = false;
			}	
		}

		//   .  (     ),     
		if (Wandering()) activeMode = false;
	}

	
	if (!activeMode)
	{
    	//    
    	activeModeStartTime = 0;
    	

    	if ((canMoving && WANDERING_MODE) || Wandering())	//    ,    
    	{
    		PlaySpeech(", -  ","   ");
    		Wandering(true);

    		//   ,      
    		speechTime = GetTickCount();
    		activeMode = false;
    		while(!activeMode)
    		{
    			//   - ,     
    			if (PlaySpeech()) speechTime = GetTickCount();

    			if (GetTickCount() - speechTime > 20000 && speechEnable) RobotPrompt();
    			sync();
    		}
    	}
    	else
    	//         (  )
    	if (MAP_MODE && canMoving)
    	{

    		//        R.Bot-
    		if (IsChargeConnected())
    		{
    			SetCurrentPlace(chargePlace);
    		}


    		//---------       ----------
    		//   ,     ,    
    		p = places[placeIndex];

    		//   
    		if (!IsWorkTime())
    		{
    			forceChargeMode = false;

    			//    ,    
    			if (!forceWorkMode)
    			{
    				//   ,    
    				if (IsChargeConnected()) continue;

					//         
					p = basePlace;
				}
    		}
    		else
    		{
    			//   

    			//    
    			forceWorkMode = false;
			}


    		//         
    		if (forceChargeMode) p = basePlace;
    		
    		//   
    		if (IsChargeConnected())
    		{
    			//     
    			//    (     )
    			//    ,   
    			if (forceChargeMode || GetBattery() < 110) continue;
			}

    		//     ,    -   
    		if (GetBattery()>=0 && GetBattery() < 30) p = basePlace;
    		//--------------        -----------------------------



    		//   
    		if (p == basePlace)
    		{
    			PlaySpeech(", -   ","    ", "     ");
			}
			else
			{
    			PlaySpeech(", -  ","   ");
    		}

    		//  
    		LockFaceTrackerHead(false);
	    	Head(0,-15);

    		//  3 .  ,    "* faceIn"
    		ClearFaceIn(6000);
    		nonfaceHello = false;

    		//     p
    		if (GoToPlace(p))
    		{
    			//       
    			Head(0,0);

    			//---------      ,    ----------
    			if (useAutoCharge && p==basePlace)
    			{
    				PlaySpeech("  ");
    				Park(true);
    				while(Park()==1) sync();
    				if (Park()==0)
    				{
    					if (IsChargeConnected())
    					{
    						SetCurrentPlace(chargePlace);
    						PlaySpeech("    ","   ","   ","      ");
						}
    				}
    				else
    				{
    					//      ,  
    					while(!IsChargeConnected())
    					{
    						SetBrowserURL('parkerror.php');
    						PlaySpeech("    ,  ",
    									"    ,  ",
    									"     .  ",
    									"     .  ");
    						
    						//  n    
    						t = GetTickCount() + rand(12000, 30000);
    						while(t - GetTickCount() > 0 && !IsChargeConnected()) sync();
						}
						SetBrowserURL('index.php');

    				}
    				continue;
    			}
    			//----------------     ---------------


    			if (p!=basePlace)
    			{
    				//   ,       
    				placeIndex++;
    				if (placeIndex >= count(places)) placeIndex = 0;
    			}	
    		}
    		else
    		{
    			//------------     ----------------
    			//      
    			// ,    -      ,
    			//   
    			if (!activeMode)
    			{
    				isError = true;
    				Head(0,0);
    				
    				while(isError)
    				{
    					//   
    					SetBrowserURL('placeerror.php');
    					PlaySpeech(" (G:|)  .  ",
    								" (G:|)  .  ",
    								" .  (G:|)  ",
    								" .  (G:|)",
    								" .  (G:|)",
    								" (G:|).  ");

    					// ,    
    					t = GetTickCount() + rand(12000, 30000);
    					while(isError && t - GetTickCount() > 0)
    					{
    						if (IsChargeConnected())
    						{
    							isError = false;
    							activeMode = true;
    							SetCurrentPlace(chargePlace);
    							break;
    						}
    						sync();
						}
    				}
    				subjectMask = 0;				//    .   ,   
					hasFace = false;				//   .    "* faceIn"  "* faceOut"
					lastGender = -1;				//    
					lastAge = -1;					//    
					lastPerson = "";				//    (  ,    ).     MySQL
					isError = false;				//   (,  )
					activeMode = true;				//  (true)   (false) .   -    .   -   
					speechEnable = true;			//     .   
					lockHello = false;				//  
    				SetBrowserURL('index.php');
    			}
    			//---------------      -------------
    		}	

    		//--------------------    ,   ------
    		speechEnable = true;
    		if (!activeMode)
    		{
    			PlaySpeech(" , '  (G:|)"," , '  (G:|)");

    			//    placeStandUpTime    
    			startT = GetTickCount();
    			goAway = false;
    			while(!goAway && !activeMode && GetTickCount() - startT < placeStandUpTime * 1000)
    			{

    				Head(rand(-15,15),rand(-15,10));
    				//  N 
    				t = GetTickCount();
    				while(!goAway && !activeMode && GetTickCount() - t < 12000)
    				{
    					sync();
    					if (PlaySpeech()) t = GetTickCount();
    					if (Wandering()) break;
    				}


    				if (!activeMode)
    				{
    					if (speechEnable)
    						RobotPrompt();		//   
    				}
    			}
    			//       ,
    			//        
    		}
    	}
    	else
    	{
    		// ,      ,   
    		//     
    		speechTime = GetTickCount();
    		activeMode = false;
    		while(!activeMode)
    		{
    			//   - ,     
    			if (PlaySpeech()) speechTime = GetTickCount();

    			if (GetTickCount() - speechTime > 20000 && speechEnable)
    			{
    				Head(rand(-15,15),rand(-10,15));
    				RobotPrompt();
				}
    			sync();
    		}
    	}
    }	
}
